Difference between revisions of "Browser plugins"

From ArchWiki
Jump to: navigation, search
m (Citrix)
m (External PDF viewers: : Added a trick to disable pdf.js)
(18 intermediate revisions by 7 users not shown)
Line 10: Line 10:
  
 
=== Gnash ===
 
=== Gnash ===
 +
{{Wikipedia|Gnash}}
 
[http://www.gnu.org/software/gnash/ GNU Gnash] is a free (libre) alternative to Adobe Flash Player. It is available both as a standalone player for desktop computers and embedded devices, as well as a browser plugin, and supports the SWF format up to version 7 (with versions 8 and 9 under development) and about 80% of ActionScript 2.0.
 
[http://www.gnu.org/software/gnash/ GNU Gnash] is a free (libre) alternative to Adobe Flash Player. It is available both as a standalone player for desktop computers and embedded devices, as well as a browser plugin, and supports the SWF format up to version 7 (with versions 8 and 9 under development) and about 80% of ActionScript 2.0.
  
Line 17: Line 18:
 
[http://lightspark.github.com/ Lightspark] is another attempt to provide a free alternative to Adobe Flash aimed at supporting newer Flash formats. Although it is still very much in development, it supports some [https://github.com/lightspark/lightspark/wiki/Site-Support popular sites].  
 
[http://lightspark.github.com/ Lightspark] is another attempt to provide a free alternative to Adobe Flash aimed at supporting newer Flash formats. Although it is still very much in development, it supports some [https://github.com/lightspark/lightspark/wiki/Site-Support popular sites].  
  
Lightspark can be [[Pacman|installed]] with the package {{AUR|lightspark-git}}, available in the [[AUR]].
+
Lightspark can be [[Pacman|installed]] with the package {{AUR|lightspark}} or {{AUR|lightspark-git}}, available in the [[AUR]].
  
 
=== Adobe Flash Player ===
 
=== Adobe Flash Player ===
Line 69: Line 70:
 
Download {{ic|Flash Fullscreen Patcher.zip}} from [http://forum.videohelp.com/threads/304807-How-to-remove-annoying-Press-Esc-to-message-in-Flash-Video this page], extract and execute with {{ic|wine}}:
 
Download {{ic|Flash Fullscreen Patcher.zip}} from [http://forum.videohelp.com/threads/304807-How-to-remove-annoying-Press-Esc-to-message-in-Flash-Video this page], extract and execute with {{ic|wine}}:
  
   $ wget http://forum.videohelp.com/attachments/9255-1319291919/Flash%20Fullscreen%20Patcher.zip
+
   $ wget http://forum.videohelp.com/attachments/14900-1354083401/Flash%20Fullscreen%20Patcher%202.0.zip
   $ unzip Flash\ Fullscreen\ Patcher.zip  
+
   $ unzip Flash\ Fullscreen\ Patcher\ 2.0.zip
   $ wine Flash\ Fullscreen\ Patcher.exe
+
   $ wine Flash\ Fullscreen\ Patcher\ 2.0.exe
  
 
Patch {{ic|libflashplayer.so}} (the one from your home directory) using the GUI.
 
Patch {{ic|libflashplayer.so}} (the one from your home directory) using the GUI.
Line 78: Line 79:
  
 
==PDF viewer==
 
==PDF viewer==
 +
 +
=== PDF.js ===
 +
{{Wikipedia|Pdf.js}}
 +
 +
[https://mozillalabs.com/en-US/pdfjs/ PDF.js] is a PDF renderer created by Mozilla and built using HTML5 technologies. It is currently only available as a Firefox [https://addons.mozilla.org/en-US/firefox/addon/pdfjs/ plugin].
  
 
=== External PDF viewers ===
 
=== External PDF viewers ===
{{Box||See the main article: [[Firefox Tweaks#Viewing PDF/PS files inside Firefox]]|#E5E5FF|#FCFCFC}}
+
To use an external PDF viewer you need [[#MozPlugger]] or [[#kpartsplugin]].
 +
 
 +
If you want to use MozPlugger with Evince, for example, you have to find the lines containing {{ic|pdf}} in the {{ic|/etc/mozpluggerrc}} file and modify the corresponding line after {{ic|GV()}} as below:  
 +
repeat noisy swallow(evince) fill: evince "$file"
 +
(replace {{ic|evince}} with something else if it is not your viewer of choice).
 +
 
 +
If this isn't enough, you may need to change 2 values in {{ic|about:config}}:
 +
* Change {{ic|pdfjs.disabled}}'s value to ''true'';
 +
* Change {{ic|plugin.disable_full_page_plugin_for_types}}'s value to an empty value.
 +
 
 +
Restart and it should work like a charm!
  
 
=== Adobe Reader ===
 
=== Adobe Reader ===
Line 98: Line 114:
 
* Follow [[Install bundled 32-bit system in Arch64|this guide]] originally posted in the forums. It involves creating a chrooted environment that could be reused for other 32-bit only applications.
 
* Follow [[Install bundled 32-bit system in Arch64|this guide]] originally posted in the forums. It involves creating a chrooted environment that could be reused for other 32-bit only applications.
  
* Install {{AUR|bin32-acroread}} (with all its 32-bit dependencies) from [[AUR]]. Be advised that the [[Firefox]] plugin cannot be used ''directly'' with this binary -- it will not load in the 64-bit browser. To load it install the {{Pkg|nspluginwrapper}} plackage from the official [[Multilib|[multilib]]] repository and run:
+
* Install {{AUR|bin32-acroread}} (with all its 32-bit dependencies) from [[AUR]]. Be advised that the [[Firefox]] plugin cannot be used ''directly'' with this binary -- it will not load in the 64-bit browser. To load it install the {{Pkg|nspluginwrapper}} package from the official [[Multilib|[multilib]]] repository and run:
 
  $ nspluginwrapper -v -a -i
 
  $ nspluginwrapper -v -a -i
 
as a normal user. This checks the plugin directory and links the plugins as needed.
 
as a normal user. This checks the plugin directory and links the plugins as needed.
Line 106: Line 122:
  
 
== Java (IcedTea) ==
 
== Java (IcedTea) ==
Provided by {{Pkg|icedtea-web-java7}} from the [[Official Repositories|official repositories]], which will also install [[Java]].
+
To enable [[Java]] support in your browser, you have two options: use either Oracle's non-free JRE or the [[Wikipedia:Openjdk|OpenJDK]] environment (recommended). For details about why OpenJDK is recommended see [https://mailman.archlinux.org/pipermail/arch-general/2011-August/021671.html this].
  
{{Note|If you experience any problems with the Java plug-in, you can try the [[Flash#Plugins_are_installed_but_not_working|solution]], suggested for the Firefox Flash plug-in. You can also try using non-free version, bundled with Oracle JRE.}}
+
To use OpenJDK, you have to install the [http://icedtea.classpath.org/wiki/Main_Page IcedTea] browser plugin:
 +
* {{Pkg|icedtea-web}} for version 6 of the Java environment.
 +
* {{Pkg|icedtea-web-java7}} for version 7 of the Java environment.
  
==Video Plugins==
+
If you want to use Oracle's JRE you have to install the {{AUR|jre}} or {{AUR|jre6}} package, available in the [[AUR]].
  
===Gecko Media Player===
+
See [[Java#OpenJDK JVM]] for additional details and references.
A good replacement of the now obsolete mplayer-plugin is [http://code.google.com/p/gecko-mediaplayer/ Gecko Media Player] packaged as {{Pkg|gecko-mediaplayer}}. More stable combined with MPlayer 1.0RC2. (No more crashes with Apple Trailers.)
+
  
===Totem Plugin===
+
{{Note|If you experience any problems with the Java plugin (it is not recognized by the browser), you can try this [[Flash#Plugins_are_installed_but_not_working|solution]].}}
The {{Pkg|totem-plugin}} might be the right choice for those seeking a [[GStreamer]]-based plugin.
+
  
===Rosa Media Player Plugin===
+
== Video Plugins ==
The {{AUR|rosa-media-player-plugin}}, available in the [[AUR]], might be the right choice for those seeking a [[MPlayer]]-based plugin written in Qt.
+
  
===VLC Plugin===
+
* {{App|Gecko Media Player|A Mozilla browser plugin to handle media on websites, using MPlayer.|https://sites.google.com/site/kdekorte2/gecko-mediaplayer|{{Pkg|gecko-mediaplayer}}}}
{{AUR|npapi-vlc-git}} is the modern VLC Mozilla plugin based on libVLC.
+
* {{App|Totem Plugin|A browser plugin based on the [[Wikipedia:Totem (software)|Totem]] media player for [[Gnome]] which uses [[Gstreamer]].|http://projects.gnome.org/totem/|{{Pkg|totem-plugin}}}}
 +
* {{App|Rosa Media Player Plugin|A Qt-based browser plugin also based on MPlayer.|https://abf.rosalinux.ru/uxteam/ROSA_Media_Player|{{AUR|rosa-media-player-plugin}}}}
 +
* {{App|VLC Plugin|A NPAPI-based plugin that uses VLC technologies.|http://git.videolan.org/?p=npapi-vlc.git;a=summary|{{AUR|npapi-vlc-git}}}}
  
==Other==
+
== Other ==
  
===Mozplugger===
+
=== MozPlugger ===
{{Stub}}
+
MozPlugger can be installed with the {{AUR|mozplugger}} package, respectively {{AUR|mozplugger-chromium}}, available in the [[AUR]].
Install {{AUR|mozplugger}} through the [[AUR]].
+
  
==Troubleshooting==
+
[http://mozplugger.mozdev.org/ MozPlugger] is a Mozilla plugin which can show many types of multimedia inside your browser. To accomplish this, it uses external programs such as MPlayer, xine, Evince, OpenOffice, TiMidity, etc. To modify or add applications to be used by MozPlugger just modify the {{ic|/etc/mozpluggerrc}} file.
  
=== Bad (choppy) sound on 64bit flashplugin ===
+
For example, MozPlugger uses OpenOffice by default to open {{ic|doc}} files. To change it to use LibreOffice instead, look for the OpenOffice section:
There is a problem with flashplugin 11 64bit and a new memcpy routine in glibc, which makes the sound choppy on mp3 streams (more info here: [http://forums.fedoraforum.org/showthread.php?t=258346]. Current workarounds are either replacing the memcopy routine like suggested in the mentioned thread or using {{AUR|flashplugin-square}} from the AUR.
+
{{hc|/etc/mozpluggerrc|
 +
...
 +
### OpenOffice
 +
define([OO],[swallow(VCLSalFrame) fill: ooffice2.0 -nologo -norestore -view $1 "$file"
 +
    swallow(VCLSalFrame) fill: ooffice -nologo -norestore -view $1 "$file"
 +
    swallow(VCLSalFrame) fill: soffice -nologo $1 "$file"])
 +
...
 +
}}
 +
and add LibreOffice at the beginning of the list:
 +
{{hc|/etc/mozpluggerrc|
 +
...
 +
### OpenOffice
 +
define([OO],[swallow(VCLSalFrame) fill: libreoffice --nologo --norestore --view $1 "$file"
 +
    swallow(VCLSalFrame) fill: ooffice2.0 -nologo -norestore -view $1 "$file"
 +
    swallow(VCLSalFrame) fill: ooffice -nologo -norestore -view $1 "$file"
 +
    swallow(VCLSalFrame) fill: soffice -nologo $1 "$file"])
 +
...
 +
}}
 +
{{Note|Be sure to also choose LibreOffice as your preferred application to open {{ic|doc}} files.}}
  
===Flash blocks sound and/or delayed playback===
+
As another simple example, if you want to open {{ic|cpp}} files with your favorite text editor (we will use Kate) to get syntax highlighting, just add a new section to your {{ic|mozpluggerrc}} file:
If sound is delayed within flash video and/or if Flash stops sound from any other application, then make sure you do not have {{ic|snd_pcm_oss}} module loaded:
+
{{hc|/etc/mozpluggerrc|
$ lsmod | grep snd_pcm_oss
+
text/x-c++:cpp:C++ Source File
You can unload it
+
text/x-c++:hpp:C++ Header File
# rmmod snd_pcm_oss
+
    repeat noisy swallow(kate) fill: kate -b "$file"
and restart the browser to see if it helps.
+
}}
 +
 
 +
For a more complete list of MozPlugger options see [http://www.linuxmanpages.com/man7/mozplugger.7.php this page].
 +
 
 +
=== kpartsplugin ===
 +
[http://www.unix-ag.uni-kl.de/~fischer/kpartsplugin/ The KParts plugin] is a plugin that uses KDE's KPart technology to embed different file viewers in the browser, such as Okular (for PDF), Ark (for different archives), Calligra Words (for ODF), etc. It cannot use applications that are not based on the KPart technology.
 +
 
 +
The KParts plugin can be installed with the package {{Pkg|kpartsplugin}}, available in the official repositories.
 +
 
 +
==Troubleshooting==
 +
 
 +
=== Flash Player: No sound ===
 +
Flash Player outputs its sound only through the default [[Advanced Linux Sound Architecture|ALSA]] device, which is number '''0'''. If you have multiple sound devices (a very common example is having a sound card and HDMI output in the video card), then your preferred device may have a different number.
  
===No sound in Flash===
+
For a list of available devices with their respective numbers, run:
Flash Player outputs its sound only through the default ALSA device, which is number 0. If you have multiple sound devices (a very common example is having a sound card and HDMI output in video card), then your preferred device may have a different number.
+
For example:
+
 
  $ aplay -l
 
  $ aplay -l
 
  **** List of PLAYBACK Hardware Devices ****
 
  **** List of PLAYBACK Hardware Devices ****
Line 156: Line 200:
 
   Subdevices: 1/1
 
   Subdevices: 1/1
 
   Subdevice #0: subdevice #0
 
   Subdevice #0: subdevice #0
In this case, HDMI output is "card 0" and sound card is "card 1". To make it default for ALSA, create a file named {{ic|~/.asoundrc}} with the following content:
+
 
pcm.!default {
+
In this case, the HDMI output is {{ic|card 0}} and the sound card is {{ic|card 1}}. To make your sound card the default for ALSA, create the file {{ic|.asoundrc}} in your home directory, with the following content:
type hw
+
{{hc|~/.asoundrc|
card 1
+
pcm.!default {
}
+
    type hw
 +
    card 1
 +
}
 
   
 
   
ctl.!default {
+
ctl.!default {
type hw
+
    type hw
card 1
+
    card 1
}
+
}
 +
}}
  
===Flash performance===
+
=== Flash Player: Blocking sound for other applications or delayed playback ===
Adobe's Flash plugin has some serious performance issues, especially when CPU frequency scaling is used. There seems to be a policy not to use the whole CPU workload, so the frequency scaling governor does not clock the CPU any higher. To work around this issue, see: [[cpufrequtils#Changing the ondemand governor's threshold]]
+
If sound is delayed within Flash videos or Flash stops sound from any other application, then make sure you do not have {{ic|snd_pcm_oss}} module loaded:
 +
$ lsmod | grep snd_pcm_oss
 +
You can unload it:
 +
# rmmod snd_pcm_oss
 +
and restart the browser to see if it helps.
  
===Plugins are installed but not working===
+
=== Flash Player: Bad (choppy) sound on the 64-bit version ===
A common problem is that the plugin path is unset. This typically occurs on a new install, when the user has not re-logged in before running Firefox after the installation. Test if the path is unset:
+
There is a problem with Flash plugin 11 on 64-bit systems and a new {{ic|memcpy}} routine in {{Pkg|glibc}} (for more details see [https://bugzilla.redhat.com/show_bug.cgi?id&#;638477 this Fefora bug report]), which makes the sound choppy on MP3 streams. Current workarounds are:
echo $MOZ_PLUGIN_PATH
+
* replacing the {{ic|memcpy}} routine as suggested in [http://forums.fedoraforum.org/showthread.php?t=258346 this thread].
If unset, then either re-login, or source {{ic|/etc/profile.d/mozilla-common.sh}} and start Firefox from the same shell:
+
* installing {{AUR|flashplugin-square}} from the [[AUR]] (this is a version of the Flash plugin with working hardware acceleration).
. /etc/profile.d/mozilla-common.sh && firefox
+
  
===Gecko Media Player will not play Apple trailers===
+
=== Flash Player: Performance ===
If Apple Trailers appear to start to play and then fail, try setting the user agent for your browser to:
+
Adobe's Flash plugin has some serious performance issues, especially when CPU frequency scaling is used. There seems to be a policy not to use the whole CPU workload, so the frequency scaling governor does not clock the CPU any higher. To work around this issue, see [[cpufrequtils#Changing the ondemand governor's threshold]]
QuickTime/7.6.2 (qtver=7.6.2;os=Windows NT 5.1Service Pack 3)
+
  
===Low webcam resolution in Flash===
+
=== Flash Player: Low webcam resolution ===
 
If your webcam has low resolution in Flash (the image looks very pixelated) you can try starting your browser with this:
 
If your webcam has low resolution in Flash (the image looks very pixelated) you can try starting your browser with this:
  LD_PRELOAD=/usr/lib/libv4l/v4l1compat.so chromium
+
  $ LD_PRELOAD=/usr/lib/libv4l/v4l1compat.so [broswer]
  
===Black bars in full screen flash playback on multi-headed setups===
+
=== Flash Player: Black bars in full screen playback on multi-headed setups ===
 
+
The Flash plugin has a known bug where the full screen mode does not really work when you have a multi-monitor setup. Apparently, it incorrectly determines the full screen resolution, so the full screen Flash Player fills the correct monitor but gets scaled as if the monitor had the resolution of the total display area.
The Flash plugin has a known bug where the full screen mode does not really work when you have a multi-monitor setup. Apparently, it incorrectly determines the full screen resolution, so the full screen flash player fills the correct monitor but gets scaled as if the monitor had the resolution of the total display area.
+
  
 
To fix this, you can use the "hack" described [http://al.robotfuzz.com/content/workaround-fullscreen-flash-linux-multiheaded-desktops here]. Simply download the source from the link given on the page, and follow the instructions in the README.
 
To fix this, you can use the "hack" described [http://al.robotfuzz.com/content/workaround-fullscreen-flash-linux-multiheaded-desktops here]. Simply download the source from the link given on the page, and follow the instructions in the README.
  
{{Tip|The hack is now in the AUR and can be downloaded [https://aur.archlinux.org/packages.php?ID=61477 here].}}
+
{{Tip|The hack is available in the [[AUR]] and can be installed with the {{AUR|fullscreenhack}} package.}}
  
 
{{Note|While the author mentions using Nvidia's TwinView, the hack should work for any multi-monitor setup.}}
 
{{Note|While the author mentions using Nvidia's TwinView, the hack should work for any multi-monitor setup.}}
  
===Blue tint on videos with Flash and Nvidia===
+
=== Flash Player: Blue tint on videos with Nvidia ===
  
 
An issue with {{Pkg|flashplugin}} versions 11.2.202.228-1 and 11.2.202.233-1 causes it to send the U/V panes in the incorrect order resulting in a blue tint on certain videos. Version 0.5 of {{Pkg|libvdpau}} includes a workaround to fix this, see the [http://lists.x.org/archives/xorg-announce/2012-September/002066.html official announcement].
 
An issue with {{Pkg|flashplugin}} versions 11.2.202.228-1 and 11.2.202.233-1 causes it to send the U/V panes in the incorrect order resulting in a blue tint on certain videos. Version 0.5 of {{Pkg|libvdpau}} includes a workaround to fix this, see the [http://lists.x.org/archives/xorg-announce/2012-September/002066.html official announcement].
  
===Leaking overlay with Flash and Nvidia===
+
=== Flash Player: Leaking overlay with Nvidia ===
  
This bug is due to the incorrect colour key being used by the {{Pkg|flashplugin}} version 11.2.202.228-1 [http://www.nvnews.net/vbulletin/showpost.php?p=2514210&postcount=102] and causes the flash content to "leak" into other pages or solid black backgrounds. To avoid this issue simply export {{ic|1=VDPAU_NVIDIA_NO_OVERLAY=1}} within either your shell profile (E.g. {{ic|~/.bash_profile}} or {{ic|~/.zprofile}}) or {{ic|~/.xinitrc}}
+
This bug is due to the incorrect color key being used by the {{Pkg|flashplugin}} version 11.2.202.228-1 (see [http://www.nvnews.net/vbulletin/showpost.php?p=2514210&postcount=102 this post] on the Nvidia forums) and causes the Flash content to "leak" into other pages or solid black backgrounds. To avoid this issue simply export {{ic|1=VDPAU_NVIDIA_NO_OVERLAY=1}} within either your shell profile (e.g. {{ic|~/.bash_profile}} or {{ic|~/.zprofile}}) or {{ic|~/.xinitrc}}
  
===Flash videos not working on older systems===
+
=== Flash Player: Videos not working on older systems ===
 
If you have Adobe Flash installed on an older system and you start playing a video which simply turns black with nothing happening, it is most likely that your CPU does not support SSE2. You can simply check this by looking at your CPU flags with this command:
 
If you have Adobe Flash installed on an older system and you start playing a video which simply turns black with nothing happening, it is most likely that your CPU does not support SSE2. You can simply check this by looking at your CPU flags with this command:
 
  # cat /proc/cpuinfo | grep sse2
 
  # cat /proc/cpuinfo | grep sse2
  
If no results are returned, then you need to install an older version of Flash (for example 10.3). Older versions possibly will have vulnerabilities. You should then consider sandboxing Firefox using sandfox (https://igurublog.wordpress.com/downloads/script-sandfox/).
+
If no results are returned, then you need to install an older version of Flash (for example 10.3). Older versions possibly will have vulnerabilities. You should then consider sandboxing Firefox using {{AUR|sandfox}}, available in the [[AUR]]. See the [https://igurublog.wordpress.com/downloads/script-sandfox/ sandfox homepage] for usage information.
  
 
Older versions of Flash are available here:
 
Older versions of Flash are available here:
Line 212: Line 260:
  
 
You need to copy {{ic|libflashplayer.so}} to the folder {{ic|/usr/lib/mozilla/plugins/}}
 
You need to copy {{ic|libflashplayer.so}} to the folder {{ic|/usr/lib/mozilla/plugins/}}
 +
 +
=== Plugins are installed but not working ===
 +
A common problem is that the plugin path is unset. This typically occurs on a new install, when the user has not re-logged in before running Firefox after the installation. Test if the path is unset:
 +
echo $MOZ_PLUGIN_PATH
 +
If unset, then either re-login, or source {{ic|/etc/profile.d/mozilla-common.sh}} and start Firefox from the same shell:
 +
. /etc/profile.d/mozilla-common.sh && firefox
 +
 +
=== Gecko Media Player will not play Apple trailers ===
 +
If Apple Trailers appear to start to play and then fail, try setting the user agent for your browser to:
 +
QuickTime/7.6.2 (qtver=7.6.2;os=Windows NT 5.1Service Pack 3)

Revision as of 19:16, 13 March 2013

These plugins work in Firefox, Opera and WebKit derivatives.

Flash Player

Gnash

Template:Wikipedia GNU Gnash is a free (libre) alternative to Adobe Flash Player. It is available both as a standalone player for desktop computers and embedded devices, as well as a browser plugin, and supports the SWF format up to version 7 (with versions 8 and 9 under development) and about 80% of ActionScript 2.0.

GNU Gnash can be installed with the package gnash-gtk, available in the official repositories.

Lightspark

Lightspark is another attempt to provide a free alternative to Adobe Flash aimed at supporting newer Flash formats. Although it is still very much in development, it supports some popular sites.

Lightspark can be installed with the package lightsparkAUR or lightspark-gitAUR, available in the AUR.

Adobe Flash Player

The Adobe Flash Player is also available in the official repositories, although it was discontinued on Linux (for both 32-bit and 64-bit). Adobe will be providing security updates for another 5 years (i.e. 2017), but new versions of the plugin will only come integrated with Google Chrome (using its new PPAPI).

Install flashplugin from the official repositories.

Note:
  • Some versions of Epiphany have trouble recognizing the Flash plugin. See Epiphany#Flash for more details.
  • The Adobe Flash Player may also require ttf-ms-fontsAUR from the AUR in order to properly render text.
Tip: Chromium can also use the Google Chrome Flash Player, see Chromium#Flash Player.

Configuration

To change the preferences (privacy settings, resource usage, etc.) of Flash Player, right click on any embedded Flash content and choose Settings from the menu, or go to the Macromedia website. There, a Flash animation will give you access to your local settings.

You can also use the Flash settings file /etc/adobe/mms.cfg. An example configuration:

/etc/adobe/mms.cfg
  # Adobe player settings
  AVHardwareDisable = 0
  FullScreenDisable = 0
  LocalFileReadDisable = 1
  FileDownloadDisable = 1
  FileUploadDisable = 1
  LocalStorageLimit = 1
  ThirdPartyStorage = 1
  AssetCacheSize = 10
  AutoUpdateDisable = 1
  LegacyDomainMatching = 0
  LocalFileLegacyAction = 0
  AllowUserLocalTrust = 0
  # DisableSockets = 1 
  OverrideGPUValidation = 1

You can also refer to the mms.cfg from Gentoo, which is extensively commented.

Disable the "Press ESC to exit full screen mode" message

For a way to disable this message see this ubuntuforums.org post.

Backup libflashplayer.so:

 # cp /usr/lib/mozilla/plugins/libflashplayer.so /usr/lib/mozilla/plugins/libflashplayer.so.backup 

Make a copy of it in your home directory:

 # cp /usr/lib/mozilla/plugins/libflashplayer.so ~/

Install wine from the official repositories.

Download Flash Fullscreen Patcher.zip from this page, extract and execute with wine:

 $ wget http://forum.videohelp.com/attachments/14900-1354083401/Flash%20Fullscreen%20Patcher%202.0.zip
 $ unzip Flash\ Fullscreen\ Patcher\ 2.0.zip
 $ wine Flash\ Fullscreen\ Patcher\ 2.0.exe

Patch libflashplayer.so (the one from your home directory) using the GUI. Copy the patched Flash Player back to the plugins directory:

 # cp ~/libflashplayer.so /usr/lib/mozilla/plugins/

PDF viewer

PDF.js

Template:Wikipedia

PDF.js is a PDF renderer created by Mozilla and built using HTML5 technologies. It is currently only available as a Firefox plugin.

External PDF viewers

To use an external PDF viewer you need #MozPlugger or #kpartsplugin.

If you want to use MozPlugger with Evince, for example, you have to find the lines containing pdf in the /etc/mozpluggerrc file and modify the corresponding line after GV() as below:

repeat noisy swallow(evince) fill: evince "$file"

(replace evince with something else if it is not your viewer of choice).

If this isn't enough, you may need to change 2 values in about:config:

  • Change pdfjs.disabled's value to true;
  • Change plugin.disable_full_page_plugin_for_types's value to an empty value.

Restart and it should work like a charm!

Adobe Reader

Due to licensing restrictions, Adobe Reader cannot be distributed from any of the official Arch Linux repositories. There are versions available in the AUR. Please note that no matter how many votes it receives, Adobe Reader will never be included in the official repositories. See this comment for an explanation.

Also, there are localizations available in many languages.

32-bit

Adobe Acrobat Reader is only available as a 32-bit binary. It can be installed with the acroreadAUR package, available in the AUR.

This package installs the Acrobat Reader application as well as the Firefox plugin. Note that hardware-assisted rendering is unavailable under Linux (at least using a Geforce 8600GTS with driver version 185.18.14).

64-bit

There is yet to be an official 64-bit version of Adobe Reader.

To use it in a 64-bit environment, you can:

  • Follow this guide originally posted in the forums. It involves creating a chrooted environment that could be reused for other 32-bit only applications.
  • Install bin32-acroreadAUR (with all its 32-bit dependencies) from AUR. Be advised that the Firefox plugin cannot be used directly with this binary -- it will not load in the 64-bit browser. To load it install the nspluginwrapper package from the official [multilib] repository and run:
$ nspluginwrapper -v -a -i

as a normal user. This checks the plugin directory and links the plugins as needed.

Citrix

Template:Box

Java (IcedTea)

To enable Java support in your browser, you have two options: use either Oracle's non-free JRE or the OpenJDK environment (recommended). For details about why OpenJDK is recommended see this.

To use OpenJDK, you have to install the IcedTea browser plugin:

If you want to use Oracle's JRE you have to install the jreAUR or jre6AUR package, available in the AUR.

See Java#OpenJDK JVM for additional details and references.

Note: If you experience any problems with the Java plugin (it is not recognized by the browser), you can try this solution.

Video Plugins

  • Gecko Media Player — A Mozilla browser plugin to handle media on websites, using MPlayer.
https://sites.google.com/site/kdekorte2/gecko-mediaplayer || gecko-mediaplayer
  • Totem Plugin — A browser plugin based on the Totem media player for Gnome which uses Gstreamer.
http://projects.gnome.org/totem/ || totem-plugin
  • Rosa Media Player Plugin — A Qt-based browser plugin also based on MPlayer.
https://abf.rosalinux.ru/uxteam/ROSA_Media_Player || rosa-media-player-pluginAUR
  • VLC Plugin — A NPAPI-based plugin that uses VLC technologies.
http://git.videolan.org/?p=npapi-vlc.git;a=summary || npapi-vlc-gitAUR

Other

MozPlugger

MozPlugger can be installed with the mozpluggerAUR package, respectively mozplugger-chromiumAUR, available in the AUR.

MozPlugger is a Mozilla plugin which can show many types of multimedia inside your browser. To accomplish this, it uses external programs such as MPlayer, xine, Evince, OpenOffice, TiMidity, etc. To modify or add applications to be used by MozPlugger just modify the /etc/mozpluggerrc file.

For example, MozPlugger uses OpenOffice by default to open doc files. To change it to use LibreOffice instead, look for the OpenOffice section:

/etc/mozpluggerrc
...
### OpenOffice
define([OO],[swallow(VCLSalFrame) fill: ooffice2.0 -nologo -norestore -view $1 "$file"
    swallow(VCLSalFrame) fill: ooffice -nologo -norestore -view $1 "$file"
    swallow(VCLSalFrame) fill: soffice -nologo $1 "$file"])
...

and add LibreOffice at the beginning of the list:

/etc/mozpluggerrc
...
### OpenOffice
define([OO],[swallow(VCLSalFrame) fill: libreoffice --nologo --norestore --view $1 "$file"
    swallow(VCLSalFrame) fill: ooffice2.0 -nologo -norestore -view $1 "$file"
    swallow(VCLSalFrame) fill: ooffice -nologo -norestore -view $1 "$file"
    swallow(VCLSalFrame) fill: soffice -nologo $1 "$file"])
...
Note: Be sure to also choose LibreOffice as your preferred application to open doc files.

As another simple example, if you want to open cpp files with your favorite text editor (we will use Kate) to get syntax highlighting, just add a new section to your mozpluggerrc file:

/etc/mozpluggerrc
text/x-c++:cpp:C++ Source File
text/x-c++:hpp:C++ Header File
    repeat noisy swallow(kate) fill: kate -b "$file"

For a more complete list of MozPlugger options see this page.

kpartsplugin

The KParts plugin is a plugin that uses KDE's KPart technology to embed different file viewers in the browser, such as Okular (for PDF), Ark (for different archives), Calligra Words (for ODF), etc. It cannot use applications that are not based on the KPart technology.

The KParts plugin can be installed with the package kpartsplugin, available in the official repositories.

Troubleshooting

Flash Player: No sound

Flash Player outputs its sound only through the default ALSA device, which is number 0. If you have multiple sound devices (a very common example is having a sound card and HDMI output in the video card), then your preferred device may have a different number.

For a list of available devices with their respective numbers, run:

$ aplay -l
**** List of PLAYBACK Hardware Devices ****
card 0: Generic [HD-Audio Generic], device 3: HDMI 0 [HDMI 0]
  Subdevices: 1/1
  Subdevice #0: subdevice #0
card 1: DX [Xonar DX], device 0: Multichannel [Multichannel]
  Subdevices: 0/1
  Subdevice #0: subdevice #0
card 1: DX [Xonar DX], device 1: Digital [Digital]
  Subdevices: 1/1
  Subdevice #0: subdevice #0

In this case, the HDMI output is card 0 and the sound card is card 1. To make your sound card the default for ALSA, create the file .asoundrc in your home directory, with the following content:

~/.asoundrc
pcm.!default {
    type hw
    card 1
}
 
ctl.!default {
    type hw
    card 1
}

Flash Player: Blocking sound for other applications or delayed playback

If sound is delayed within Flash videos or Flash stops sound from any other application, then make sure you do not have snd_pcm_oss module loaded:

$ lsmod | grep snd_pcm_oss

You can unload it:

# rmmod snd_pcm_oss

and restart the browser to see if it helps.

Flash Player: Bad (choppy) sound on the 64-bit version

There is a problem with Flash plugin 11 on 64-bit systems and a new memcpy routine in glibc (for more details see this Fefora bug report), which makes the sound choppy on MP3 streams. Current workarounds are:

  • replacing the memcpy routine as suggested in this thread.
  • installing flashplugin-squareAUR from the AUR (this is a version of the Flash plugin with working hardware acceleration).

Flash Player: Performance

Adobe's Flash plugin has some serious performance issues, especially when CPU frequency scaling is used. There seems to be a policy not to use the whole CPU workload, so the frequency scaling governor does not clock the CPU any higher. To work around this issue, see cpufrequtils#Changing the ondemand governor's threshold

Flash Player: Low webcam resolution

If your webcam has low resolution in Flash (the image looks very pixelated) you can try starting your browser with this:

$ LD_PRELOAD=/usr/lib/libv4l/v4l1compat.so [broswer]

Flash Player: Black bars in full screen playback on multi-headed setups

The Flash plugin has a known bug where the full screen mode does not really work when you have a multi-monitor setup. Apparently, it incorrectly determines the full screen resolution, so the full screen Flash Player fills the correct monitor but gets scaled as if the monitor had the resolution of the total display area.

To fix this, you can use the "hack" described here. Simply download the source from the link given on the page, and follow the instructions in the README.

Tip: The hack is available in the AUR and can be installed with the fullscreenhackAUR package.
Note: While the author mentions using Nvidia's TwinView, the hack should work for any multi-monitor setup.

Flash Player: Blue tint on videos with Nvidia

An issue with flashplugin versions 11.2.202.228-1 and 11.2.202.233-1 causes it to send the U/V panes in the incorrect order resulting in a blue tint on certain videos. Version 0.5 of libvdpau includes a workaround to fix this, see the official announcement.

Flash Player: Leaking overlay with Nvidia

This bug is due to the incorrect color key being used by the flashplugin version 11.2.202.228-1 (see this post on the Nvidia forums) and causes the Flash content to "leak" into other pages or solid black backgrounds. To avoid this issue simply export VDPAU_NVIDIA_NO_OVERLAY=1 within either your shell profile (e.g. ~/.bash_profile or ~/.zprofile) or ~/.xinitrc

Flash Player: Videos not working on older systems

If you have Adobe Flash installed on an older system and you start playing a video which simply turns black with nothing happening, it is most likely that your CPU does not support SSE2. You can simply check this by looking at your CPU flags with this command:

# cat /proc/cpuinfo | grep sse2

If no results are returned, then you need to install an older version of Flash (for example 10.3). Older versions possibly will have vulnerabilities. You should then consider sandboxing Firefox using sandfoxAUR, available in the AUR. See the sandfox homepage for usage information.

Older versions of Flash are available here: http://www.adobe.com/products/flashplayer/distribution3.html

You need to copy libflashplayer.so to the folder /usr/lib/mozilla/plugins/

Plugins are installed but not working

A common problem is that the plugin path is unset. This typically occurs on a new install, when the user has not re-logged in before running Firefox after the installation. Test if the path is unset:

echo $MOZ_PLUGIN_PATH

If unset, then either re-login, or source /etc/profile.d/mozilla-common.sh and start Firefox from the same shell:

. /etc/profile.d/mozilla-common.sh && firefox

Gecko Media Player will not play Apple trailers

If Apple Trailers appear to start to play and then fail, try setting the user agent for your browser to:

QuickTime/7.6.2 (qtver=7.6.2;os=Windows NT 5.1Service Pack 3)